function opl00300_acompanhamento_pedido_OL_Controller(ScreenService, templateManager, ZhFilterPreferences, General, MessageService) {

    //Armazena o CDFILIAL
    var var_CDFILIAL;
    
    //Armazena a data de entrega
    var var_DATAENTREGA_start;
    var var_DATAENTREGA_end;
    
    //Armazena a data de solicitação
    var var_DATASOLICITACAO_start;
    var var_DATASOLICITACAO_end;

    //Abre o filtro
	this.openFilter = function(widget) {
    	ScreenService.showLoader();
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.UNIDADESOLICITANTE = 'T';
		rowsToSet.NUMEROCONSOLIDACAO = 'T';
		widget.getField("UNIDADESOLICITANTE").filterProperties.readOnly = true;
		widget.getField("UNIDADE").filterProperties.readOnly = true;
		delete widget.getField("UNIDADE").validations.required;
		widget.getField("NUMEROCONSOLIDACAO").filterProperties.readOnly = true;
		widget.getField("NRSEQUCONSOL").filterProperties.readOnly = true;
		delete widget.getField("NRSEQUCONSOL").validations.required;
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			ScreenService.hideLoader();
		}).catch(error => {
			ScreenService.hideLoader();
		});
    };
    
    //Seta o filtro a trazer os dados para o grid
    this.setDataSourceFilter = function (args) {
        const widget = templateManager.container.getWidget('gridFilialSolicitante');
        const row = args.e.preference.FILTER_ROW;
        widget.dataSourceFilter.push(
            {
                "name": "P_CDFILOL",
                "operator": "=",
                "value": row.CDFILIAL
            }
        );
        //Remove campos nao necessários no filtro
        widget.dataSourceFilter.forEach(function(item, index) {
            if(item.name === "FILIALOL"){
                widget.dataSourceFilter.splice(index, index);
            }
            if(item.name === "PEDIDOMAIOR"){
                widget.dataSourceFilter.splice(index, index);
            }
            if(item.name === "PEDIDOMENOR"){
                widget.dataSourceFilter.splice(index, index);
            }
            if(item.name === "PEDIDOIGUAL"){
                widget.dataSourceFilter.splice(index, index);
            }
        });
        widget.reload();
    };
    
    //Altera o comportamento do campo UNIDADE
    this.changeFieldUnidade = function(args){
    	var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.UNIDADESOLICITANTE == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("UNIDADE").readOnly = true;
					delete widget.getField("UNIDADE").validations.required;
					widget.currentRow.CDFILIAL = "";
					widget.currentRow.NMFILIAL = "";
					widget.getField("UNIDADE").clearValue();
					widget.getField("UNIDADE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.UNIDADESOLICITANTE == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("UNIDADE").readOnly = false;
					widget.getField("UNIDADE").validations.required = true;
					widget.getField("UNIDADE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
    };
    
	//Altera o comportamento do campo CONSOLIDAÇÃO
    this.changeFieldConsolidacao = function(args){
    	var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.NUMEROCONSOLIDACAO == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NRSEQUCONSOL").readOnly = true;
					delete widget.getField("NRSEQUCONSOL").validations.required;
					widget.currentRow.CODIGO = "";
					widget.currentRow.NOME = "";
					widget.getField("NRSEQUCONSOL").clearValue();
					widget.getField("NRSEQUCONSOL").reload();
					widget.getField("STATUSED").readOnly = false;
					widget.currentRow.STATUSED = "S";
					widget.getField("ITEMCONSOLNAO").readOnly = false;
					widget.currentRow.ITEMCONSOLNAO = "S";
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.NUMEROCONSOLIDACAO == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NRSEQUCONSOL").readOnly = false;
					widget.getField("NRSEQUCONSOL").validations.required = true;
					widget.getField("NRSEQUCONSOL").reload();
					widget.getField("STATUSED").readOnly = true;
					widget.currentRow.STATUSED = "N";
					widget.getField("ITEMCONSOLNAO").readOnly = true;
					widget.currentRow.ITEMCONSOLNAO = "N";
					ScreenService.hideLoader();
				}, 200);
			}
		}
    };
    
    //Armazena o valor do CDFILIAL
    this.storeCDFILIAL = function(args){
        var_CDFILIAL = args.owner.owner.widget.currentRow.CDFILIAL;
    };
    
    //Armazena o valor do DATA DE ENTREGA
    this.storeDATAENTREGA = function(args){
        var_DATAENTREGA_start = args.owner.owner.widget.currentRow.DATAENTREGA.start;
        var_DATAENTREGA_end = args.owner.owner.widget.currentRow.DATAENTREGA.end;
    };
    
    //Armazena o valor do DATA DE SOLICITAÇÃO
    this.storeDATASOLICITACAO = function(args){
        var_DATASOLICITACAO_start = args.owner.owner.widget.currentRow.DATASOLICITACAO.start;
        var_DATASOLICITACAO_end = args.owner.owner.widget.currentRow.DATASOLICITACAO.end;
    };
    
    //Retorna os valores do filtro
    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBeforeApply = templateManager.container.getActiveWidget();
            
            //test about how widget is... (field or filter)
    	    if(filterBeforeApply.label != 'Filtro'){		
    		    filterBeforeApply = filterBeforeApply.lastActiveWidget;
                filterWidget = filterBeforeApply;
                
            }
            if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions') {
            	filterWidget = filterBeforeApply;
            }
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
            }
            // Insert values
            if(filterWidget) {
                var valueField;
                if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
    //Retorna o valor do CDFILIAL
    this.getFieldValueCDFILIAL = function(){
        return var_CDFILIAL;
    };
    
    //Retorna a data Entrada da DATA DE ENTRADA
    this.getEntradaDataEntrega = function(data_entrada) {
        if (data_entrada) {
            return data_entrada.start;
        } else {
            return null;  
        }
    };
    
    //Retorna a data Final da DATA DE ENTRADA
    this.getFinalDataEntrega = function(data_entrada) {
        if (data_entrada) {
            return data_entrada.end;
        } else {
            return null;  
        }
    };
    
    //Retorna a data Entrada da DATA DE SOLICITAÇÃO
    this.getEntradaDataSolicitacao = function(data_solicitacao) {
        if (data_solicitacao) {
            return data_solicitacao.start;
        } else {
            return null;  
        }
    };
    
    //Retorna a data Final da DATA DE SOLICITAÇÃO
    this.getFinalDataSolicitacao = function(data_solicitacao) {
        if (data_solicitacao) {
            return data_solicitacao.end;
        } else {
            return null;  
        }
    };
    
    //Retorna as data de inicio necessária como parametro para a dataRourceFilter do campo CONSOLIDAÇÃO
    this.getDataInicialForNumeroConsolidacao = function(parameter) {
        if(parameter === 'inicio'){
            if(var_DATAENTREGA_start && var_DATAENTREGA_end) {
                return var_DATAENTREGA_start;
            } else if(var_DATASOLICITACAO_start && var_DATASOLICITACAO_end) {
                return var_DATASOLICITACAO_start;
            } else {
                return null;
            }
        }
    };
    
    //Retorna as data final necessária como parametro para a dataRourceFilter do campo CONSOLIDAÇÃO
    this.getDataFinalForNumeroConsolidacao = function(parameter) {
        if(parameter === 'fim'){
            if(var_DATAENTREGA_start && var_DATAENTREGA_end) {
                return var_DATAENTREGA_end;
            } else if(var_DATASOLICITACAO_start && var_DATASOLICITACAO_end) {
                return var_DATASOLICITACAO_end;
            } else {
                return null;
            }
        }
    };
    
    //Verifica o status da field STATUS a ser filtrado
    this.verificaStatus = function(STATUSED, STATUSOL) {
        //Se ED (Entrega Direta) e OL (Entrega via OL) estiverem marcados retorna "T"
        if(STATUSED == "S" && STATUSOL == "S"){
            return "T";
        //Se ED (Entrega Direta) estiver marcado e OL (Entrega via OL) não estiver marcado retorna "S"
        } else if(STATUSED == "S" && STATUSOL == "N"){
            return "S";
        //Se ED (Entrega Direta) Não estiver marcado e OL (Entrega via OL) estiver marcado retorna "N"
        } else if(STATUSED == "N" && STATUSOL == "S") {
            return "N";
        }
    };
    
    //Verifica o item consolidado da field ITEM CONSOLIDADO a ser filtrado
    this.verificaItemConsolidado = function(ITEMCONSOLSIM, ITEMCONSOLNAO) {
        //Se as opções SIM e NÃO estiverem marcados retorna "T"
        if(ITEMCONSOLSIM == "S" && ITEMCONSOLNAO == "S"){
            return "T";
        //Se a opção SIM estiver marcado e a opção NÃO não estiver marcado retorna "S"
        } else if(ITEMCONSOLSIM == "S" && ITEMCONSOLNAO == "N"){
            return "S";
        //Se a opção SIM não estiver marcado e a opção NÃO estiver marcado retorna "N"
        } else if(ITEMCONSOLSIM == "N" && ITEMCONSOLNAO == "S") {
            return "N";
        }
    };
    
    //Verifica o pedido gerado da field PEDIDO GERADO a ser filtrado
    this.verificaPedidoGerado = function(ITEMCONSOLSIM, ITEMCONSOLNAO) {
        //Se as opções SIM e NÃO estiverem marcados retorna "T"
        if(ITEMCONSOLSIM == "S" && ITEMCONSOLNAO == "S"){
            return "T";
        //Se a opção SIM estiver marcado e a opção NÃO não estiver marcado retorna "S"
        } else if(ITEMCONSOLSIM == "S" && ITEMCONSOLNAO == "N"){
            return "S";
        //Se a opção SIM não estiver marcado e a opção NÃO estiver marcado retorna "N"
        } else if(ITEMCONSOLSIM == "N" && ITEMCONSOLNAO == "S") {
            return "N";
        }
    };
    
    //Verifica os campos da field QNTD. PEDIDO a ser filtrado
    this.verificaQtdPedido = function(PEDIDOMAIOR, PEDIDOMENOR, PEDIDOIGUAL) {
        //Se somente a opção Maior que o solicitado estiver marcado
        if(PEDIDOMAIOR == "S" && PEDIDOMENOR == "N" && PEDIDOIGUAL == "N"){
            return "A";
        //Se somente a opção Menor que o Solicitado estiver marcado
        } else if(PEDIDOMAIOR == "N" && PEDIDOMENOR == "S" && PEDIDOIGUAL == "N"){
            return "B";
        //Se somente a opção Igual ao Solicitado estiver marcado
        } else if(PEDIDOMAIOR == "N" && PEDIDOMENOR == "N" && PEDIDOIGUAL == "S"){
            return "C";
        //Se somente as opções Maior que o Solicitado e Igual ao Solicitado estiverem marcados
        } else if(PEDIDOMAIOR == "S" && PEDIDOMENOR == "N" && PEDIDOIGUAL == "S"){
            return "D";
        //Se somente as opções Menor que o Solicitado e Igual ao Solicitado estiverem marcados
        } else if(PEDIDOMAIOR == "N" && PEDIDOMENOR == "S" && PEDIDOIGUAL == "S"){
            return "E";
        //Se somente as opções Maior que o Solicitado e Menor que o Solicitado estiverem marcados
        } else if(PEDIDOMAIOR == "S" && PEDIDOMENOR == "S" && PEDIDOIGUAL == "N"){
            return "F";
        //Se todos estiverem marcados
        } else if(PEDIDOMAIOR == "S" && PEDIDOMENOR == "S" && PEDIDOIGUAL == "S"){
            return "T";
        }
    };
    
    //Concatenação de parametros
    this.concatArrayForParams = function(arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("opl00300_acompanhamento_pedido_OL_Controller", opl00300_acompanhamento_pedido_OL_Controller);
});